/* NavigationRail.c generated by valac 0.56.18, the Vala compiler
 * generated from NavigationRail.vala, do not modify */

/*
 * Copyright (c) 2022-2025 Fyra Labs
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 3 of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this program; if not, write to the
 * Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
 * Boston, MA 02110-1301 USA
 */

#include "libhelium-1.h"
#include <gtk/gtk.h>
#include <glib.h>
#include <gio/gio.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <glib/gi18n-lib.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

enum  {
	HE_NAVIGATION_RAIL_0_PROPERTY,
	HE_NAVIGATION_RAIL_STACK_PROPERTY,
	HE_NAVIGATION_RAIL_ORIENTATION_PROPERTY,
	HE_NAVIGATION_RAIL_HIDE_LABELS_PROPERTY,
	HE_NAVIGATION_RAIL_IS_EXPANDED_PROPERTY,
	HE_NAVIGATION_RAIL_CUSTOM_BUTTON_PROPERTY,
	HE_NAVIGATION_RAIL_CUSTOM_WIDGET_PROPERTY,
	HE_NAVIGATION_RAIL_NUM_PROPERTIES
};
static GParamSpec* he_navigation_rail_properties[HE_NAVIGATION_RAIL_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_regex_unref0(var) ((var == NULL) ? NULL : (var = (g_regex_unref (var), NULL)))
typedef struct _Block12Data Block12Data;

struct _HeNavigationRailPrivate {
	GtkSelectionModel* _stack_pages;
	GList* _buttons;
	GtkBox* main_box;
	HeButton* expand_button;
	GtkButton* _custom_button;
	GtkWidget* _custom_widget;
	GtkStack* _stack;
	GtkOrientation _orientation;
	gboolean _hide_labels;
	gboolean _is_expanded;
};

struct _Block12Data {
	int _ref_count_;
	HeNavigationRail* self;
	GtkToggleButton* button;
};

static gint HeNavigationRail_private_offset;
static gpointer he_navigation_rail_parent_class = NULL;

static void _g_object_unref0_ (gpointer var);
static inline void _g_list_free__g_object_unref0_ (GList* self);
static void he_navigation_rail_on_selected_stack_page_changed (HeNavigationRail* self,
                                                        guint position,
                                                        guint n_items);
static void _he_navigation_rail_on_selected_stack_page_changed_gtk_selection_model_selection_changed (GtkSelectionModel* _sender,
                                                                                               guint position,
                                                                                               guint n_items,
                                                                                               gpointer self);
static void he_navigation_rail_on_stack_pages_changed (HeNavigationRail* self,
                                                guint position,
                                                guint removed,
                                                guint added);
static void _he_navigation_rail_on_stack_pages_changed_g_list_model_items_changed (GListModel* _sender,
                                                                            guint position,
                                                                            guint removed,
                                                                            guint added,
                                                                            gpointer self);
static void he_navigation_rail_update_orientation_layout (HeNavigationRail* self);
static void he_navigation_rail_update_label_visibility (HeNavigationRail* self);
static void he_navigation_rail_update_expansion_state (HeNavigationRail* self);
static void he_navigation_rail_update_custom_widget_visibility (HeNavigationRail* self);
static void he_navigation_rail_update_expanded_button (HeNavigationRail* self);
static void he_navigation_rail_update_page_icon (HeNavigationRail* self,
                                          GtkStackPage* page,
                                          gboolean is_active);
static Block12Data* block12_data_ref (Block12Data* _data12_);
static void block12_data_unref (void * _userdata_);
static void ___lambda142_ (Block12Data* _data12_);
static void he_navigation_rail_on_button_toggled (HeNavigationRail* self,
                                           GtkToggleButton* button);
static void ____lambda142__gtk_toggle_button_toggled (GtkToggleButton* _sender,
                                               gpointer self);
static GObject * he_navigation_rail_constructor (GType type,
                                          guint n_construct_properties,
                                          GObjectConstructParam * construct_properties);
static void _he_navigation_rail___lambda143_ (HeNavigationRail* self);
static void __he_navigation_rail___lambda143__gtk_button_clicked (GtkButton* _sender,
                                                           gpointer self);
static void he_navigation_rail_finalize (GObject * obj);
static GType he_navigation_rail_get_type_once (void);
static void _vala_he_navigation_rail_get_property (GObject * object,
                                            guint property_id,
                                            GValue * value,
                                            GParamSpec * pspec);
static void _vala_he_navigation_rail_set_property (GObject * object,
                                            guint property_id,
                                            const GValue * value,
                                            GParamSpec * pspec);
static inline gpointer _vala_memdup2 (gconstpointer mem,
                        gsize byte_size);

static inline gpointer
he_navigation_rail_get_instance_private (HeNavigationRail* self)
{
	return G_STRUCT_MEMBER_P (self, HeNavigationRail_private_offset);
}

static void
_g_object_unref0_ (gpointer var)
{
#line 25 "../lib/Widgets/NavigationRail.vala"
	(var == NULL) ? NULL : (var = (g_object_unref (var), NULL));
#line 143 "NavigationRail.c"
}

static inline void
_g_list_free__g_object_unref0_ (GList* self)
{
#line 25 "../lib/Widgets/NavigationRail.vala"
	g_list_free_full (self, (GDestroyNotify) _g_object_unref0_);
#line 151 "NavigationRail.c"
}

GtkStack*
he_navigation_rail_get_stack (HeNavigationRail* self)
{
	GtkStack* result;
	GtkStack* _tmp0_;
#line 38 "../lib/Widgets/NavigationRail.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 38 "../lib/Widgets/NavigationRail.vala"
	_tmp0_ = self->priv->_stack;
#line 38 "../lib/Widgets/NavigationRail.vala"
	result = _tmp0_;
#line 38 "../lib/Widgets/NavigationRail.vala"
	return result;
#line 167 "NavigationRail.c"
}

static void
_he_navigation_rail_on_selected_stack_page_changed_gtk_selection_model_selection_changed (GtkSelectionModel* _sender,
                                                                                          guint position,
                                                                                          guint n_items,
                                                                                          gpointer self)
{
#line 43 "../lib/Widgets/NavigationRail.vala"
	he_navigation_rail_on_selected_stack_page_changed ((HeNavigationRail*) self, position, n_items);
#line 178 "NavigationRail.c"
}

static void
_he_navigation_rail_on_stack_pages_changed_g_list_model_items_changed (GListModel* _sender,
                                                                       guint position,
                                                                       guint removed,
                                                                       guint added,
                                                                       gpointer self)
{
#line 44 "../lib/Widgets/NavigationRail.vala"
	he_navigation_rail_on_stack_pages_changed ((HeNavigationRail*) self, position, removed, added);
#line 190 "NavigationRail.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 47 "../lib/Widgets/NavigationRail.vala"
	return self ? g_object_ref (self) : NULL;
#line 198 "NavigationRail.c"
}

void
he_navigation_rail_set_stack (HeNavigationRail* self,
                              GtkStack* value)
{
	GtkStack* _tmp0_;
	GtkSelectionModel* _tmp1_;
	GtkStack* _tmp6_;
#line 39 "../lib/Widgets/NavigationRail.vala"
	g_return_if_fail (self != NULL);
#line 40 "../lib/Widgets/NavigationRail.vala"
	_tmp0_ = self->priv->_stack;
#line 40 "../lib/Widgets/NavigationRail.vala"
	if (_tmp0_ == value) {
#line 40 "../lib/Widgets/NavigationRail.vala"
		return;
#line 216 "NavigationRail.c"
	}
#line 42 "../lib/Widgets/NavigationRail.vala"
	_tmp1_ = self->priv->_stack_pages;
#line 42 "../lib/Widgets/NavigationRail.vala"
	if (_tmp1_ != NULL) {
#line 222 "NavigationRail.c"
		GtkSelectionModel* _tmp2_;
		guint _tmp3_;
		GtkSelectionModel* _tmp4_;
		guint _tmp5_;
#line 43 "../lib/Widgets/NavigationRail.vala"
		_tmp2_ = self->priv->_stack_pages;
#line 43 "../lib/Widgets/NavigationRail.vala"
		g_signal_parse_name ("selection-changed", gtk_selection_model_get_type (), &_tmp3_, NULL, FALSE);
#line 43 "../lib/Widgets/NavigationRail.vala"
		g_signal_handlers_disconnect_matched (_tmp2_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp3_, 0, NULL, (GCallback) _he_navigation_rail_on_selected_stack_page_changed_gtk_selection_model_selection_changed, self);
#line 44 "../lib/Widgets/NavigationRail.vala"
		_tmp4_ = self->priv->_stack_pages;
#line 44 "../lib/Widgets/NavigationRail.vala"
		g_signal_parse_name ("items-changed", g_list_model_get_type (), &_tmp5_, NULL, FALSE);
#line 44 "../lib/Widgets/NavigationRail.vala"
		g_signal_handlers_disconnect_matched ((GListModel*) _tmp4_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp5_, 0, NULL, (GCallback) _he_navigation_rail_on_stack_pages_changed_g_list_model_items_changed, self);
#line 239 "NavigationRail.c"
	}
#line 47 "../lib/Widgets/NavigationRail.vala"
	_tmp6_ = _g_object_ref0 (value);
#line 47 "../lib/Widgets/NavigationRail.vala"
	_g_object_unref0 (self->priv->_stack);
#line 47 "../lib/Widgets/NavigationRail.vala"
	self->priv->_stack = _tmp6_;
#line 48 "../lib/Widgets/NavigationRail.vala"
	if (value != NULL) {
#line 249 "NavigationRail.c"
		GtkSelectionModel* _tmp7_;
		GtkSelectionModel* _tmp8_;
		GtkSelectionModel* _tmp9_;
		GtkSelectionModel* _tmp10_;
		GtkSelectionModel* _tmp11_;
#line 49 "../lib/Widgets/NavigationRail.vala"
		_tmp7_ = gtk_stack_get_pages (value);
#line 49 "../lib/Widgets/NavigationRail.vala"
		_tmp8_ = _tmp7_;
#line 49 "../lib/Widgets/NavigationRail.vala"
		_g_object_unref0 (self->priv->_stack_pages);
#line 49 "../lib/Widgets/NavigationRail.vala"
		self->priv->_stack_pages = _tmp8_;
#line 50 "../lib/Widgets/NavigationRail.vala"
		_tmp9_ = self->priv->_stack_pages;
#line 50 "../lib/Widgets/NavigationRail.vala"
		g_signal_connect_object (_tmp9_, "selection-changed", (GCallback) _he_navigation_rail_on_selected_stack_page_changed_gtk_selection_model_selection_changed, self, 0);
#line 51 "../lib/Widgets/NavigationRail.vala"
		_tmp10_ = self->priv->_stack_pages;
#line 51 "../lib/Widgets/NavigationRail.vala"
		g_signal_connect_object ((GListModel*) _tmp10_, "items-changed", (GCallback) _he_navigation_rail_on_stack_pages_changed_g_list_model_items_changed, self, 0);
#line 52 "../lib/Widgets/NavigationRail.vala"
		_tmp11_ = self->priv->_stack_pages;
#line 52 "../lib/Widgets/NavigationRail.vala"
		he_navigation_rail_on_stack_pages_changed (self, (guint) 0, (guint) 0, g_list_model_get_n_items ((GListModel*) _tmp11_));
#line 275 "NavigationRail.c"
	}
#line 39 "../lib/Widgets/NavigationRail.vala"
	g_object_notify_by_pspec ((GObject *) self, he_navigation_rail_properties[HE_NAVIGATION_RAIL_STACK_PROPERTY]);
#line 279 "NavigationRail.c"
}

GtkOrientation
he_navigation_rail_get_orientation (HeNavigationRail* self)
{
	GtkOrientation result;
#line 64 "../lib/Widgets/NavigationRail.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 64 "../lib/Widgets/NavigationRail.vala"
	result = self->priv->_orientation;
#line 64 "../lib/Widgets/NavigationRail.vala"
	return result;
#line 292 "NavigationRail.c"
}

void
he_navigation_rail_set_orientation (HeNavigationRail* self,
                                    GtkOrientation value)
{
#line 65 "../lib/Widgets/NavigationRail.vala"
	g_return_if_fail (self != NULL);
#line 66 "../lib/Widgets/NavigationRail.vala"
	if (self->priv->_orientation == value) {
#line 66 "../lib/Widgets/NavigationRail.vala"
		return;
#line 305 "NavigationRail.c"
	}
#line 68 "../lib/Widgets/NavigationRail.vala"
	self->priv->_orientation = value;
#line 69 "../lib/Widgets/NavigationRail.vala"
	he_navigation_rail_update_orientation_layout (self);
#line 65 "../lib/Widgets/NavigationRail.vala"
	g_object_notify_by_pspec ((GObject *) self, he_navigation_rail_properties[HE_NAVIGATION_RAIL_ORIENTATION_PROPERTY]);
#line 313 "NavigationRail.c"
}

gboolean
he_navigation_rail_get_hide_labels (HeNavigationRail* self)
{
	gboolean result;
#line 80 "../lib/Widgets/NavigationRail.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 80 "../lib/Widgets/NavigationRail.vala"
	result = self->priv->_hide_labels;
#line 80 "../lib/Widgets/NavigationRail.vala"
	return result;
#line 326 "NavigationRail.c"
}

void
he_navigation_rail_set_hide_labels (HeNavigationRail* self,
                                    gboolean value)
{
#line 81 "../lib/Widgets/NavigationRail.vala"
	g_return_if_fail (self != NULL);
#line 82 "../lib/Widgets/NavigationRail.vala"
	if (self->priv->_hide_labels == value) {
#line 82 "../lib/Widgets/NavigationRail.vala"
		return;
#line 339 "NavigationRail.c"
	}
#line 84 "../lib/Widgets/NavigationRail.vala"
	self->priv->_hide_labels = value;
#line 85 "../lib/Widgets/NavigationRail.vala"
	he_navigation_rail_update_label_visibility (self);
#line 81 "../lib/Widgets/NavigationRail.vala"
	g_object_notify_by_pspec ((GObject *) self, he_navigation_rail_properties[HE_NAVIGATION_RAIL_HIDE_LABELS_PROPERTY]);
#line 347 "NavigationRail.c"
}

gboolean
he_navigation_rail_get_is_expanded (HeNavigationRail* self)
{
	gboolean result;
#line 96 "../lib/Widgets/NavigationRail.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 96 "../lib/Widgets/NavigationRail.vala"
	result = self->priv->_is_expanded;
#line 96 "../lib/Widgets/NavigationRail.vala"
	return result;
#line 360 "NavigationRail.c"
}

void
he_navigation_rail_set_is_expanded (HeNavigationRail* self,
                                    gboolean value)
{
#line 97 "../lib/Widgets/NavigationRail.vala"
	g_return_if_fail (self != NULL);
#line 98 "../lib/Widgets/NavigationRail.vala"
	if (self->priv->_is_expanded == value) {
#line 98 "../lib/Widgets/NavigationRail.vala"
		return;
#line 373 "NavigationRail.c"
	}
#line 100 "../lib/Widgets/NavigationRail.vala"
	self->priv->_is_expanded = value;
#line 101 "../lib/Widgets/NavigationRail.vala"
	he_navigation_rail_update_expansion_state (self);
#line 97 "../lib/Widgets/NavigationRail.vala"
	g_object_notify_by_pspec ((GObject *) self, he_navigation_rail_properties[HE_NAVIGATION_RAIL_IS_EXPANDED_PROPERTY]);
#line 381 "NavigationRail.c"
}

GtkButton*
he_navigation_rail_get_custom_button (HeNavigationRail* self)
{
	GtkButton* result;
	GtkButton* _tmp0_;
#line 111 "../lib/Widgets/NavigationRail.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 111 "../lib/Widgets/NavigationRail.vala"
	_tmp0_ = self->priv->_custom_button;
#line 111 "../lib/Widgets/NavigationRail.vala"
	result = _tmp0_;
#line 111 "../lib/Widgets/NavigationRail.vala"
	return result;
#line 397 "NavigationRail.c"
}

void
he_navigation_rail_set_custom_button (HeNavigationRail* self,
                                      GtkButton* value)
{
	GtkButton* _tmp0_;
	GtkButton* _tmp1_;
	GtkButton* _tmp3_;
	GtkButton* _tmp4_;
#line 112 "../lib/Widgets/NavigationRail.vala"
	g_return_if_fail (self != NULL);
#line 113 "../lib/Widgets/NavigationRail.vala"
	_tmp0_ = self->priv->_custom_button;
#line 113 "../lib/Widgets/NavigationRail.vala"
	if (_tmp0_ == value) {
#line 113 "../lib/Widgets/NavigationRail.vala"
		return;
#line 416 "NavigationRail.c"
	}
#line 115 "../lib/Widgets/NavigationRail.vala"
	_tmp1_ = self->priv->_custom_button;
#line 115 "../lib/Widgets/NavigationRail.vala"
	if (_tmp1_ != NULL) {
#line 422 "NavigationRail.c"
		GtkButton* _tmp2_;
#line 116 "../lib/Widgets/NavigationRail.vala"
		_tmp2_ = self->priv->_custom_button;
#line 116 "../lib/Widgets/NavigationRail.vala"
		gtk_widget_unparent ((GtkWidget*) _tmp2_);
#line 428 "NavigationRail.c"
	}
#line 119 "../lib/Widgets/NavigationRail.vala"
	_tmp3_ = _g_object_ref0 (value);
#line 119 "../lib/Widgets/NavigationRail.vala"
	_g_object_unref0 (self->priv->_custom_button);
#line 119 "../lib/Widgets/NavigationRail.vala"
	self->priv->_custom_button = _tmp3_;
#line 121 "../lib/Widgets/NavigationRail.vala"
	_tmp4_ = self->priv->_custom_button;
#line 121 "../lib/Widgets/NavigationRail.vala"
	if (_tmp4_ != NULL) {
#line 440 "NavigationRail.c"
		GtkBox* _tmp5_;
		GtkButton* _tmp6_;
		HeButton* _tmp7_;
#line 123 "../lib/Widgets/NavigationRail.vala"
		_tmp5_ = self->priv->main_box;
#line 123 "../lib/Widgets/NavigationRail.vala"
		_tmp6_ = self->priv->_custom_button;
#line 123 "../lib/Widgets/NavigationRail.vala"
		_tmp7_ = self->priv->expand_button;
#line 123 "../lib/Widgets/NavigationRail.vala"
		gtk_box_insert_child_after (_tmp5_, (GtkWidget*) _tmp6_, (GtkWidget*) _tmp7_);
#line 452 "NavigationRail.c"
	}
#line 112 "../lib/Widgets/NavigationRail.vala"
	g_object_notify_by_pspec ((GObject *) self, he_navigation_rail_properties[HE_NAVIGATION_RAIL_CUSTOM_BUTTON_PROPERTY]);
#line 456 "NavigationRail.c"
}

GtkWidget*
he_navigation_rail_get_custom_widget (HeNavigationRail* self)
{
	GtkWidget* result;
	GtkWidget* _tmp0_;
#line 134 "../lib/Widgets/NavigationRail.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 134 "../lib/Widgets/NavigationRail.vala"
	_tmp0_ = self->priv->_custom_widget;
#line 134 "../lib/Widgets/NavigationRail.vala"
	result = _tmp0_;
#line 134 "../lib/Widgets/NavigationRail.vala"
	return result;
#line 472 "NavigationRail.c"
}

void
he_navigation_rail_set_custom_widget (HeNavigationRail* self,
                                      GtkWidget* value)
{
	GtkWidget* _tmp0_;
	GtkWidget* _tmp1_;
	GtkWidget* _tmp3_;
	GtkWidget* _tmp4_;
#line 135 "../lib/Widgets/NavigationRail.vala"
	g_return_if_fail (self != NULL);
#line 136 "../lib/Widgets/NavigationRail.vala"
	_tmp0_ = self->priv->_custom_widget;
#line 136 "../lib/Widgets/NavigationRail.vala"
	if (_tmp0_ == value) {
#line 136 "../lib/Widgets/NavigationRail.vala"
		return;
#line 491 "NavigationRail.c"
	}
#line 138 "../lib/Widgets/NavigationRail.vala"
	_tmp1_ = self->priv->_custom_widget;
#line 138 "../lib/Widgets/NavigationRail.vala"
	if (_tmp1_ != NULL) {
#line 497 "NavigationRail.c"
		GtkWidget* _tmp2_;
#line 139 "../lib/Widgets/NavigationRail.vala"
		_tmp2_ = self->priv->_custom_widget;
#line 139 "../lib/Widgets/NavigationRail.vala"
		gtk_widget_unparent (_tmp2_);
#line 503 "NavigationRail.c"
	}
#line 142 "../lib/Widgets/NavigationRail.vala"
	_tmp3_ = _g_object_ref0 (value);
#line 142 "../lib/Widgets/NavigationRail.vala"
	_g_object_unref0 (self->priv->_custom_widget);
#line 142 "../lib/Widgets/NavigationRail.vala"
	self->priv->_custom_widget = _tmp3_;
#line 144 "../lib/Widgets/NavigationRail.vala"
	_tmp4_ = self->priv->_custom_widget;
#line 144 "../lib/Widgets/NavigationRail.vala"
	if (_tmp4_ != NULL) {
#line 515 "NavigationRail.c"
		GtkBox* _tmp5_;
		GtkWidget* _tmp6_;
#line 145 "../lib/Widgets/NavigationRail.vala"
		_tmp5_ = self->priv->main_box;
#line 145 "../lib/Widgets/NavigationRail.vala"
		_tmp6_ = self->priv->_custom_widget;
#line 145 "../lib/Widgets/NavigationRail.vala"
		gtk_box_append (_tmp5_, _tmp6_);
#line 146 "../lib/Widgets/NavigationRail.vala"
		he_navigation_rail_update_custom_widget_visibility (self);
#line 526 "NavigationRail.c"
	}
#line 135 "../lib/Widgets/NavigationRail.vala"
	g_object_notify_by_pspec ((GObject *) self, he_navigation_rail_properties[HE_NAVIGATION_RAIL_CUSTOM_WIDGET_PROPERTY]);
#line 530 "NavigationRail.c"
}

/**
     * Creates a new NavigationRail.
     */
HeNavigationRail*
he_navigation_rail_construct (GType object_type)
{
	HeNavigationRail * self = NULL;
#line 155 "../lib/Widgets/NavigationRail.vala"
	self = (HeNavigationRail*) he_bin_construct (object_type);
#line 154 "../lib/Widgets/NavigationRail.vala"
	return self;
#line 544 "NavigationRail.c"
}

HeNavigationRail*
he_navigation_rail_new (void)
{
#line 154 "../lib/Widgets/NavigationRail.vala"
	return he_navigation_rail_construct (HE_TYPE_NAVIGATION_RAIL);
#line 552 "NavigationRail.c"
}

static void
he_navigation_rail_update_orientation_layout (HeNavigationRail* self)
{
	GtkBox* _tmp0_;
	GtkLayoutManager* _tmp1_;
#line 185 "../lib/Widgets/NavigationRail.vala"
	g_return_if_fail (self != NULL);
#line 186 "../lib/Widgets/NavigationRail.vala"
	_tmp0_ = self->priv->main_box;
#line 186 "../lib/Widgets/NavigationRail.vala"
	gtk_orientable_set_orientation ((GtkOrientable*) _tmp0_, self->priv->_orientation);
#line 187 "../lib/Widgets/NavigationRail.vala"
	_tmp1_ = gtk_widget_get_layout_manager ((GtkWidget*) self);
#line 187 "../lib/Widgets/NavigationRail.vala"
	gtk_orientable_set_orientation ((GtkOrientable*) G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, gtk_box_layout_get_type (), GtkBoxLayout), self->priv->_orientation);
#line 189 "../lib/Widgets/NavigationRail.vala"
	if (self->priv->_orientation == GTK_ORIENTATION_VERTICAL) {
#line 572 "NavigationRail.c"
		GtkBox* _tmp2_;
		GtkBox* _tmp3_;
		HeButton* _tmp4_;
		HeButton* _tmp5_;
#line 190 "../lib/Widgets/NavigationRail.vala"
		_tmp2_ = self->priv->main_box;
#line 190 "../lib/Widgets/NavigationRail.vala"
		gtk_widget_set_valign ((GtkWidget*) _tmp2_, GTK_ALIGN_CENTER);
#line 191 "../lib/Widgets/NavigationRail.vala"
		_tmp3_ = self->priv->main_box;
#line 191 "../lib/Widgets/NavigationRail.vala"
		gtk_widget_set_halign ((GtkWidget*) _tmp3_, GTK_ALIGN_FILL);
#line 192 "../lib/Widgets/NavigationRail.vala"
		_tmp4_ = self->priv->expand_button;
#line 192 "../lib/Widgets/NavigationRail.vala"
		gtk_widget_set_margin_top ((GtkWidget*) _tmp4_, 42);
#line 193 "../lib/Widgets/NavigationRail.vala"
		_tmp5_ = self->priv->expand_button;
#line 193 "../lib/Widgets/NavigationRail.vala"
		gtk_widget_set_visible ((GtkWidget*) _tmp5_, TRUE);
#line 194 "../lib/Widgets/NavigationRail.vala"
		gtk_widget_set_vexpand ((GtkWidget*) self, TRUE);
#line 195 "../lib/Widgets/NavigationRail.vala"
		gtk_widget_set_hexpand ((GtkWidget*) self, FALSE);
#line 597 "NavigationRail.c"
	} else {
		GtkBox* _tmp6_;
		GtkBox* _tmp7_;
		HeButton* _tmp8_;
		HeButton* _tmp9_;
#line 197 "../lib/Widgets/NavigationRail.vala"
		_tmp6_ = self->priv->main_box;
#line 197 "../lib/Widgets/NavigationRail.vala"
		gtk_widget_set_valign ((GtkWidget*) _tmp6_, GTK_ALIGN_FILL);
#line 198 "../lib/Widgets/NavigationRail.vala"
		_tmp7_ = self->priv->main_box;
#line 198 "../lib/Widgets/NavigationRail.vala"
		gtk_widget_set_halign ((GtkWidget*) _tmp7_, GTK_ALIGN_CENTER);
#line 199 "../lib/Widgets/NavigationRail.vala"
		_tmp8_ = self->priv->expand_button;
#line 199 "../lib/Widgets/NavigationRail.vala"
		gtk_widget_set_margin_top ((GtkWidget*) _tmp8_, 0);
#line 200 "../lib/Widgets/NavigationRail.vala"
		_tmp9_ = self->priv->expand_button;
#line 200 "../lib/Widgets/NavigationRail.vala"
		gtk_widget_set_visible ((GtkWidget*) _tmp9_, FALSE);
#line 201 "../lib/Widgets/NavigationRail.vala"
		gtk_widget_set_vexpand ((GtkWidget*) self, FALSE);
#line 202 "../lib/Widgets/NavigationRail.vala"
		gtk_widget_set_hexpand ((GtkWidget*) self, TRUE);
#line 623 "NavigationRail.c"
	}
#line 204 "../lib/Widgets/NavigationRail.vala"
	he_navigation_rail_update_custom_widget_visibility (self);
#line 627 "NavigationRail.c"
}

static void
he_navigation_rail_update_expansion_state (HeNavigationRail* self)
{
#line 207 "../lib/Widgets/NavigationRail.vala"
	g_return_if_fail (self != NULL);
#line 208 "../lib/Widgets/NavigationRail.vala"
	if (self->priv->_is_expanded) {
#line 637 "NavigationRail.c"
		GtkBox* _tmp0_;
		GtkBox* _tmp1_;
		HeButton* _tmp2_;
		HeButton* _tmp3_;
		HeButton* _tmp4_;
#line 209 "../lib/Widgets/NavigationRail.vala"
		_tmp0_ = self->priv->main_box;
#line 209 "../lib/Widgets/NavigationRail.vala"
		gtk_widget_add_css_class ((GtkWidget*) _tmp0_, "expanded");
#line 210 "../lib/Widgets/NavigationRail.vala"
		_tmp1_ = self->priv->main_box;
#line 210 "../lib/Widgets/NavigationRail.vala"
		gtk_widget_remove_css_class ((GtkWidget*) _tmp1_, "collapsed");
#line 211 "../lib/Widgets/NavigationRail.vala"
		_tmp2_ = self->priv->expand_button;
#line 211 "../lib/Widgets/NavigationRail.vala"
		gtk_button_set_icon_name ((GtkButton*) _tmp2_, "nav-expanded-symbolic");
#line 212 "../lib/Widgets/NavigationRail.vala"
		_tmp3_ = self->priv->expand_button;
#line 212 "../lib/Widgets/NavigationRail.vala"
		gtk_widget_set_margin_start ((GtkWidget*) _tmp3_, 42);
#line 213 "../lib/Widgets/NavigationRail.vala"
		_tmp4_ = self->priv->expand_button;
#line 213 "../lib/Widgets/NavigationRail.vala"
		gtk_widget_set_halign ((GtkWidget*) _tmp4_, GTK_ALIGN_START);
#line 663 "NavigationRail.c"
	} else {
		GtkBox* _tmp5_;
		GtkBox* _tmp6_;
		HeButton* _tmp7_;
		HeButton* _tmp8_;
		HeButton* _tmp9_;
#line 215 "../lib/Widgets/NavigationRail.vala"
		_tmp5_ = self->priv->main_box;
#line 215 "../lib/Widgets/NavigationRail.vala"
		gtk_widget_add_css_class ((GtkWidget*) _tmp5_, "collapsed");
#line 216 "../lib/Widgets/NavigationRail.vala"
		_tmp6_ = self->priv->main_box;
#line 216 "../lib/Widgets/NavigationRail.vala"
		gtk_widget_remove_css_class ((GtkWidget*) _tmp6_, "expanded");
#line 217 "../lib/Widgets/NavigationRail.vala"
		_tmp7_ = self->priv->expand_button;
#line 217 "../lib/Widgets/NavigationRail.vala"
		gtk_button_set_icon_name ((GtkButton*) _tmp7_, "nav-list-symbolic");
#line 218 "../lib/Widgets/NavigationRail.vala"
		_tmp8_ = self->priv->expand_button;
#line 218 "../lib/Widgets/NavigationRail.vala"
		gtk_widget_set_margin_start ((GtkWidget*) _tmp8_, 0);
#line 219 "../lib/Widgets/NavigationRail.vala"
		_tmp9_ = self->priv->expand_button;
#line 219 "../lib/Widgets/NavigationRail.vala"
		gtk_widget_set_halign ((GtkWidget*) _tmp9_, GTK_ALIGN_CENTER);
#line 690 "NavigationRail.c"
	}
#line 221 "../lib/Widgets/NavigationRail.vala"
	he_navigation_rail_update_expanded_button (self);
#line 222 "../lib/Widgets/NavigationRail.vala"
	he_navigation_rail_update_custom_widget_visibility (self);
#line 696 "NavigationRail.c"
}

static void
he_navigation_rail_update_custom_widget_visibility (HeNavigationRail* self)
{
	GtkWidget* _tmp0_;
#line 225 "../lib/Widgets/NavigationRail.vala"
	g_return_if_fail (self != NULL);
#line 226 "../lib/Widgets/NavigationRail.vala"
	_tmp0_ = self->priv->_custom_widget;
#line 226 "../lib/Widgets/NavigationRail.vala"
	if (_tmp0_ != NULL) {
#line 709 "NavigationRail.c"
		gboolean _tmp1_ = FALSE;
		GtkWidget* _tmp2_;
#line 228 "../lib/Widgets/NavigationRail.vala"
		if (self->priv->_orientation == GTK_ORIENTATION_VERTICAL) {
#line 228 "../lib/Widgets/NavigationRail.vala"
			_tmp1_ = self->priv->_is_expanded;
#line 716 "NavigationRail.c"
		} else {
#line 228 "../lib/Widgets/NavigationRail.vala"
			_tmp1_ = FALSE;
#line 720 "NavigationRail.c"
		}
#line 228 "../lib/Widgets/NavigationRail.vala"
		_tmp2_ = self->priv->_custom_widget;
#line 228 "../lib/Widgets/NavigationRail.vala"
		gtk_widget_set_visible (_tmp2_, _tmp1_);
#line 726 "NavigationRail.c"
	}
}

static void
he_navigation_rail_update_label_visibility (HeNavigationRail* self)
{
	GList* button_link = NULL;
	GList* _tmp0_;
	GList* _tmp1_;
#line 232 "../lib/Widgets/NavigationRail.vala"
	g_return_if_fail (self != NULL);
#line 233 "../lib/Widgets/NavigationRail.vala"
	_tmp0_ = self->priv->_buttons;
#line 233 "../lib/Widgets/NavigationRail.vala"
	_tmp1_ = g_list_first (_tmp0_);
#line 233 "../lib/Widgets/NavigationRail.vala"
	button_link = _tmp1_;
#line 234 "../lib/Widgets/NavigationRail.vala"
	while (TRUE) {
#line 746 "NavigationRail.c"
		GList* _tmp2_;
		GtkToggleButton* button = NULL;
		GList* _tmp3_;
		gconstpointer _tmp4_;
		GtkToggleButton* _tmp5_;
		GtkBox* button_child = NULL;
		GtkToggleButton* _tmp6_;
		GtkWidget* _tmp7_;
		GtkBox* _tmp8_;
		GtkBox* _tmp9_;
		GList* _tmp21_;
		GList* _tmp22_;
#line 234 "../lib/Widgets/NavigationRail.vala"
		_tmp2_ = button_link;
#line 234 "../lib/Widgets/NavigationRail.vala"
		if (!(_tmp2_ != NULL)) {
#line 234 "../lib/Widgets/NavigationRail.vala"
			break;
#line 765 "NavigationRail.c"
		}
#line 235 "../lib/Widgets/NavigationRail.vala"
		_tmp3_ = button_link;
#line 235 "../lib/Widgets/NavigationRail.vala"
		_tmp4_ = _tmp3_->data;
#line 235 "../lib/Widgets/NavigationRail.vala"
		_tmp5_ = _g_object_ref0 ((GtkToggleButton*) _tmp4_);
#line 235 "../lib/Widgets/NavigationRail.vala"
		button = _tmp5_;
#line 236 "../lib/Widgets/NavigationRail.vala"
		_tmp6_ = button;
#line 236 "../lib/Widgets/NavigationRail.vala"
		_tmp7_ = gtk_button_get_child ((GtkButton*) _tmp6_);
#line 236 "../lib/Widgets/NavigationRail.vala"
		_tmp8_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_tmp7_, gtk_box_get_type ()) ? ((GtkBox*) _tmp7_) : NULL);
#line 236 "../lib/Widgets/NavigationRail.vala"
		button_child = _tmp8_;
#line 237 "../lib/Widgets/NavigationRail.vala"
		_tmp9_ = button_child;
#line 237 "../lib/Widgets/NavigationRail.vala"
		if (_tmp9_ != NULL) {
#line 787 "NavigationRail.c"
			GtkLabel* label = NULL;
			GtkBox* _tmp10_;
			GtkWidget* _tmp11_;
			GtkLabel* _tmp12_;
			GtkImage* image = NULL;
			GtkBox* _tmp13_;
			GtkWidget* _tmp14_;
			GtkImage* _tmp15_;
			gboolean _tmp16_ = FALSE;
			GtkLabel* _tmp17_;
#line 238 "../lib/Widgets/NavigationRail.vala"
			_tmp10_ = button_child;
#line 238 "../lib/Widgets/NavigationRail.vala"
			_tmp11_ = gtk_widget_get_last_child ((GtkWidget*) _tmp10_);
#line 238 "../lib/Widgets/NavigationRail.vala"
			_tmp12_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_tmp11_, gtk_label_get_type ()) ? ((GtkLabel*) _tmp11_) : NULL);
#line 238 "../lib/Widgets/NavigationRail.vala"
			label = _tmp12_;
#line 239 "../lib/Widgets/NavigationRail.vala"
			_tmp13_ = button_child;
#line 239 "../lib/Widgets/NavigationRail.vala"
			_tmp14_ = gtk_widget_get_first_child ((GtkWidget*) _tmp13_);
#line 239 "../lib/Widgets/NavigationRail.vala"
			_tmp15_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_tmp14_, gtk_image_get_type ()) ? ((GtkImage*) _tmp14_) : NULL);
#line 239 "../lib/Widgets/NavigationRail.vala"
			image = _tmp15_;
#line 240 "../lib/Widgets/NavigationRail.vala"
			_tmp17_ = label;
#line 240 "../lib/Widgets/NavigationRail.vala"
			if (_tmp17_ != NULL) {
#line 818 "NavigationRail.c"
				GtkImage* _tmp18_;
#line 240 "../lib/Widgets/NavigationRail.vala"
				_tmp18_ = image;
#line 240 "../lib/Widgets/NavigationRail.vala"
				_tmp16_ = _tmp18_ != NULL;
#line 824 "NavigationRail.c"
			} else {
#line 240 "../lib/Widgets/NavigationRail.vala"
				_tmp16_ = FALSE;
#line 828 "NavigationRail.c"
			}
#line 240 "../lib/Widgets/NavigationRail.vala"
			if (_tmp16_) {
#line 832 "NavigationRail.c"
				GtkLabel* _tmp19_;
				GtkImage* _tmp20_;
#line 241 "../lib/Widgets/NavigationRail.vala"
				_tmp19_ = label;
#line 241 "../lib/Widgets/NavigationRail.vala"
				gtk_widget_set_visible ((GtkWidget*) _tmp19_, !self->priv->_hide_labels);
#line 242 "../lib/Widgets/NavigationRail.vala"
				_tmp20_ = image;
#line 242 "../lib/Widgets/NavigationRail.vala"
				gtk_widget_set_vexpand ((GtkWidget*) _tmp20_, self->priv->_hide_labels);
#line 843 "NavigationRail.c"
			}
#line 237 "../lib/Widgets/NavigationRail.vala"
			_g_object_unref0 (image);
#line 237 "../lib/Widgets/NavigationRail.vala"
			_g_object_unref0 (label);
#line 849 "NavigationRail.c"
		}
#line 245 "../lib/Widgets/NavigationRail.vala"
		_tmp21_ = button_link;
#line 245 "../lib/Widgets/NavigationRail.vala"
		_tmp22_ = _tmp21_->next;
#line 245 "../lib/Widgets/NavigationRail.vala"
		button_link = _tmp22_;
#line 234 "../lib/Widgets/NavigationRail.vala"
		_g_object_unref0 (button_child);
#line 234 "../lib/Widgets/NavigationRail.vala"
		_g_object_unref0 (button);
#line 861 "NavigationRail.c"
	}
}

static void
he_navigation_rail_update_expanded_button (HeNavigationRail* self)
{
	GList* button_link = NULL;
	GList* _tmp0_;
	GList* _tmp1_;
#line 249 "../lib/Widgets/NavigationRail.vala"
	g_return_if_fail (self != NULL);
#line 250 "../lib/Widgets/NavigationRail.vala"
	_tmp0_ = self->priv->_buttons;
#line 250 "../lib/Widgets/NavigationRail.vala"
	_tmp1_ = g_list_first (_tmp0_);
#line 250 "../lib/Widgets/NavigationRail.vala"
	button_link = _tmp1_;
#line 251 "../lib/Widgets/NavigationRail.vala"
	while (TRUE) {
#line 881 "NavigationRail.c"
		GList* _tmp2_;
		GtkToggleButton* button = NULL;
		GList* _tmp3_;
		gconstpointer _tmp4_;
		GtkToggleButton* _tmp5_;
		GtkBox* button_child = NULL;
		GtkToggleButton* _tmp6_;
		GtkWidget* _tmp7_;
		GtkBox* _tmp8_;
		GtkBox* _tmp9_;
		GList* _tmp12_;
		GList* _tmp13_;
#line 251 "../lib/Widgets/NavigationRail.vala"
		_tmp2_ = button_link;
#line 251 "../lib/Widgets/NavigationRail.vala"
		if (!(_tmp2_ != NULL)) {
#line 251 "../lib/Widgets/NavigationRail.vala"
			break;
#line 900 "NavigationRail.c"
		}
#line 252 "../lib/Widgets/NavigationRail.vala"
		_tmp3_ = button_link;
#line 252 "../lib/Widgets/NavigationRail.vala"
		_tmp4_ = _tmp3_->data;
#line 252 "../lib/Widgets/NavigationRail.vala"
		_tmp5_ = _g_object_ref0 ((GtkToggleButton*) _tmp4_);
#line 252 "../lib/Widgets/NavigationRail.vala"
		button = _tmp5_;
#line 253 "../lib/Widgets/NavigationRail.vala"
		_tmp6_ = button;
#line 253 "../lib/Widgets/NavigationRail.vala"
		_tmp7_ = gtk_button_get_child ((GtkButton*) _tmp6_);
#line 253 "../lib/Widgets/NavigationRail.vala"
		_tmp8_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_tmp7_, gtk_box_get_type ()) ? ((GtkBox*) _tmp7_) : NULL);
#line 253 "../lib/Widgets/NavigationRail.vala"
		button_child = _tmp8_;
#line 254 "../lib/Widgets/NavigationRail.vala"
		_tmp9_ = button_child;
#line 254 "../lib/Widgets/NavigationRail.vala"
		if (_tmp9_ != NULL) {
#line 255 "../lib/Widgets/NavigationRail.vala"
			if (self->priv->_is_expanded) {
#line 924 "NavigationRail.c"
				GtkBox* _tmp10_;
#line 256 "../lib/Widgets/NavigationRail.vala"
				_tmp10_ = button_child;
#line 256 "../lib/Widgets/NavigationRail.vala"
				gtk_orientable_set_orientation ((GtkOrientable*) _tmp10_, GTK_ORIENTATION_HORIZONTAL);
#line 930 "NavigationRail.c"
			} else {
				GtkBox* _tmp11_;
#line 258 "../lib/Widgets/NavigationRail.vala"
				_tmp11_ = button_child;
#line 258 "../lib/Widgets/NavigationRail.vala"
				gtk_orientable_set_orientation ((GtkOrientable*) _tmp11_, GTK_ORIENTATION_VERTICAL);
#line 937 "NavigationRail.c"
			}
		}
#line 261 "../lib/Widgets/NavigationRail.vala"
		_tmp12_ = button_link;
#line 261 "../lib/Widgets/NavigationRail.vala"
		_tmp13_ = _tmp12_->next;
#line 261 "../lib/Widgets/NavigationRail.vala"
		button_link = _tmp13_;
#line 251 "../lib/Widgets/NavigationRail.vala"
		_g_object_unref0 (button_child);
#line 251 "../lib/Widgets/NavigationRail.vala"
		_g_object_unref0 (button);
#line 950 "NavigationRail.c"
	}
}

static gboolean
string_contains (const gchar* self,
                 const gchar* needle)
{
	gchar* _tmp0_;
	gboolean result;
#line 1584 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1584 "glib-2.0.vapi"
	g_return_val_if_fail (needle != NULL, FALSE);
#line 1585 "glib-2.0.vapi"
	_tmp0_ = strstr ((gchar*) self, (gchar*) needle);
#line 1585 "glib-2.0.vapi"
	result = _tmp0_ != NULL;
#line 1585 "glib-2.0.vapi"
	return result;
#line 970 "NavigationRail.c"
}

static gchar*
string_replace (const gchar* self,
                const gchar* old,
                const gchar* replacement)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	GError* _inner_error0_ = NULL;
	gchar* result;
#line 1588 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1588 "glib-2.0.vapi"
	g_return_val_if_fail (old != NULL, NULL);
#line 1588 "glib-2.0.vapi"
	g_return_val_if_fail (replacement != NULL, NULL);
#line 1589 "glib-2.0.vapi"
	if ((*((gchar*) self)) == '\0') {
#line 1589 "glib-2.0.vapi"
		_tmp1_ = TRUE;
#line 992 "NavigationRail.c"
	} else {
#line 1589 "glib-2.0.vapi"
		_tmp1_ = (*((gchar*) old)) == '\0';
#line 996 "NavigationRail.c"
	}
#line 1589 "glib-2.0.vapi"
	if (_tmp1_) {
#line 1589 "glib-2.0.vapi"
		_tmp0_ = TRUE;
#line 1002 "NavigationRail.c"
	} else {
#line 1589 "glib-2.0.vapi"
		_tmp0_ = g_strcmp0 (old, replacement) == 0;
#line 1006 "NavigationRail.c"
	}
#line 1589 "glib-2.0.vapi"
	if (_tmp0_) {
#line 1010 "NavigationRail.c"
		gchar* _tmp2_;
#line 1590 "glib-2.0.vapi"
		_tmp2_ = g_strdup (self);
#line 1590 "glib-2.0.vapi"
		result = _tmp2_;
#line 1590 "glib-2.0.vapi"
		return result;
#line 1018 "NavigationRail.c"
	}
	{
		GRegex* regex = NULL;
		gchar* _tmp3_;
		gchar* _tmp4_;
		GRegex* _tmp5_;
		GRegex* _tmp6_;
		gchar* _tmp7_ = NULL;
		GRegex* _tmp8_;
		gchar* _tmp9_;
		gchar* _tmp10_;
#line 1593 "glib-2.0.vapi"
		_tmp3_ = g_regex_escape_string (old, -1);
#line 1593 "glib-2.0.vapi"
		_tmp4_ = _tmp3_;
#line 1593 "glib-2.0.vapi"
		_tmp5_ = g_regex_new (_tmp4_, 0, 0, &_inner_error0_);
#line 1593 "glib-2.0.vapi"
		_tmp6_ = _tmp5_;
#line 1593 "glib-2.0.vapi"
		_g_free0 (_tmp4_);
#line 1593 "glib-2.0.vapi"
		regex = _tmp6_;
#line 1593 "glib-2.0.vapi"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1593 "glib-2.0.vapi"
			if (_inner_error0_->domain == G_REGEX_ERROR) {
#line 1046 "NavigationRail.c"
				goto __catch0_g_regex_error;
			}
#line 1593 "glib-2.0.vapi"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1593 "glib-2.0.vapi"
			g_clear_error (&_inner_error0_);
#line 1593 "glib-2.0.vapi"
			return NULL;
#line 1055 "NavigationRail.c"
		}
#line 1594 "glib-2.0.vapi"
		_tmp8_ = regex;
#line 1594 "glib-2.0.vapi"
		_tmp9_ = g_regex_replace_literal (_tmp8_, self, (gssize) -1, 0, replacement, 0, &_inner_error0_);
#line 1594 "glib-2.0.vapi"
		_tmp7_ = _tmp9_;
#line 1594 "glib-2.0.vapi"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1594 "glib-2.0.vapi"
			_g_regex_unref0 (regex);
#line 1594 "glib-2.0.vapi"
			if (_inner_error0_->domain == G_REGEX_ERROR) {
#line 1069 "NavigationRail.c"
				goto __catch0_g_regex_error;
			}
#line 1594 "glib-2.0.vapi"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1594 "glib-2.0.vapi"
			g_clear_error (&_inner_error0_);
#line 1594 "glib-2.0.vapi"
			return NULL;
#line 1078 "NavigationRail.c"
		}
#line 1594 "glib-2.0.vapi"
		_tmp10_ = _tmp7_;
#line 1594 "glib-2.0.vapi"
		_tmp7_ = NULL;
#line 1594 "glib-2.0.vapi"
		result = _tmp10_;
#line 1594 "glib-2.0.vapi"
		_g_free0 (_tmp7_);
#line 1594 "glib-2.0.vapi"
		_g_regex_unref0 (regex);
#line 1594 "glib-2.0.vapi"
		return result;
#line 1092 "NavigationRail.c"
	}
	goto __finally0;
	__catch0_g_regex_error:
	{
#line 1592 "glib-2.0.vapi"
		g_clear_error (&_inner_error0_);
#line 1596 "glib-2.0.vapi"
		g_assert_not_reached ();
#line 1101 "NavigationRail.c"
	}
	__finally0:
#line 1592 "glib-2.0.vapi"
	g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1592 "glib-2.0.vapi"
	g_clear_error (&_inner_error0_);
#line 1592 "glib-2.0.vapi"
	return NULL;
#line 1110 "NavigationRail.c"
}

static void
he_navigation_rail_update_page_icon (HeNavigationRail* self,
                                     GtkStackPage* page,
                                     gboolean is_active)
{
#line 265 "../lib/Widgets/NavigationRail.vala"
	g_return_if_fail (self != NULL);
#line 265 "../lib/Widgets/NavigationRail.vala"
	g_return_if_fail (page != NULL);
#line 266 "../lib/Widgets/NavigationRail.vala"
	if (is_active) {
#line 1124 "NavigationRail.c"
		const gchar* _tmp0_;
		const gchar* _tmp1_;
#line 267 "../lib/Widgets/NavigationRail.vala"
		_tmp0_ = gtk_stack_page_get_icon_name (page);
#line 267 "../lib/Widgets/NavigationRail.vala"
		_tmp1_ = _tmp0_;
#line 267 "../lib/Widgets/NavigationRail.vala"
		if (string_contains (_tmp1_, "-symbolic")) {
#line 1133 "NavigationRail.c"
			const gchar* _tmp2_;
			const gchar* _tmp3_;
			gchar* _tmp4_;
			gchar* _tmp5_;
			gchar* _tmp6_;
			gchar* _tmp7_;
#line 268 "../lib/Widgets/NavigationRail.vala"
			_tmp2_ = gtk_stack_page_get_icon_name (page);
#line 268 "../lib/Widgets/NavigationRail.vala"
			_tmp3_ = _tmp2_;
#line 268 "../lib/Widgets/NavigationRail.vala"
			_tmp4_ = string_replace (_tmp3_, "-filled", "");
#line 268 "../lib/Widgets/NavigationRail.vala"
			_tmp5_ = _tmp4_;
#line 268 "../lib/Widgets/NavigationRail.vala"
			_tmp6_ = string_replace (_tmp5_, "-symbolic", "-filled-symbolic");
#line 268 "../lib/Widgets/NavigationRail.vala"
			_tmp7_ = _tmp6_;
#line 268 "../lib/Widgets/NavigationRail.vala"
			gtk_stack_page_set_icon_name (page, _tmp7_);
#line 268 "../lib/Widgets/NavigationRail.vala"
			_g_free0 (_tmp7_);
#line 268 "../lib/Widgets/NavigationRail.vala"
			_g_free0 (_tmp5_);
#line 1158 "NavigationRail.c"
		} else {
			const gchar* _tmp8_;
			const gchar* _tmp9_;
			gchar* _tmp10_;
			gchar* _tmp11_;
			gchar* _tmp12_;
			gchar* _tmp13_;
#line 270 "../lib/Widgets/NavigationRail.vala"
			_tmp8_ = gtk_stack_page_get_icon_name (page);
#line 270 "../lib/Widgets/NavigationRail.vala"
			_tmp9_ = _tmp8_;
#line 270 "../lib/Widgets/NavigationRail.vala"
			_tmp10_ = string_replace (_tmp9_, "-filled", "");
#line 270 "../lib/Widgets/NavigationRail.vala"
			_tmp11_ = _tmp10_;
#line 270 "../lib/Widgets/NavigationRail.vala"
			_tmp12_ = g_strconcat (_tmp11_, "-filled-symbolic", NULL);
#line 270 "../lib/Widgets/NavigationRail.vala"
			_tmp13_ = _tmp12_;
#line 270 "../lib/Widgets/NavigationRail.vala"
			gtk_stack_page_set_icon_name (page, _tmp13_);
#line 270 "../lib/Widgets/NavigationRail.vala"
			_g_free0 (_tmp13_);
#line 270 "../lib/Widgets/NavigationRail.vala"
			_g_free0 (_tmp11_);
#line 1184 "NavigationRail.c"
		}
	} else {
		const gchar* _tmp14_;
		const gchar* _tmp15_;
		gchar* _tmp16_;
		gchar* _tmp17_;
#line 273 "../lib/Widgets/NavigationRail.vala"
		_tmp14_ = gtk_stack_page_get_icon_name (page);
#line 273 "../lib/Widgets/NavigationRail.vala"
		_tmp15_ = _tmp14_;
#line 273 "../lib/Widgets/NavigationRail.vala"
		_tmp16_ = string_replace (_tmp15_, "-filled", "");
#line 273 "../lib/Widgets/NavigationRail.vala"
		_tmp17_ = _tmp16_;
#line 273 "../lib/Widgets/NavigationRail.vala"
		gtk_stack_page_set_icon_name (page, _tmp17_);
#line 273 "../lib/Widgets/NavigationRail.vala"
		_g_free0 (_tmp17_);
#line 1203 "NavigationRail.c"
	}
}

static Block12Data*
block12_data_ref (Block12Data* _data12_)
{
#line 288 "../lib/Widgets/NavigationRail.vala"
	g_atomic_int_inc (&_data12_->_ref_count_);
#line 288 "../lib/Widgets/NavigationRail.vala"
	return _data12_;
#line 1214 "NavigationRail.c"
}

static void
block12_data_unref (void * _userdata_)
{
	Block12Data* _data12_;
	_data12_ = (Block12Data*) _userdata_;
#line 288 "../lib/Widgets/NavigationRail.vala"
	if (g_atomic_int_dec_and_test (&_data12_->_ref_count_)) {
#line 1224 "NavigationRail.c"
		HeNavigationRail* self;
#line 288 "../lib/Widgets/NavigationRail.vala"
		self = _data12_->self;
#line 288 "../lib/Widgets/NavigationRail.vala"
		_g_object_unref0 (_data12_->button);
#line 288 "../lib/Widgets/NavigationRail.vala"
		_g_object_unref0 (self);
#line 288 "../lib/Widgets/NavigationRail.vala"
		g_slice_free (Block12Data, _data12_);
#line 1234 "NavigationRail.c"
	}
}

static void
___lambda142_ (Block12Data* _data12_)
{
	HeNavigationRail* self;
	GtkToggleButton* _tmp0_;
#line 313 "../lib/Widgets/NavigationRail.vala"
	self = _data12_->self;
#line 313 "../lib/Widgets/NavigationRail.vala"
	_tmp0_ = _data12_->button;
#line 313 "../lib/Widgets/NavigationRail.vala"
	he_navigation_rail_on_button_toggled (self, _tmp0_);
#line 1249 "NavigationRail.c"
}

static void
____lambda142__gtk_toggle_button_toggled (GtkToggleButton* _sender,
                                          gpointer self)
{
#line 313 "../lib/Widgets/NavigationRail.vala"
	___lambda142_ (self);
#line 1258 "NavigationRail.c"
}

static inline gboolean
vala_g_list_is_empty (GList* self)
{
	gboolean result;
#line 5301 "glib-2.0.vapi"
	result = ((GList*) self) == NULL;
#line 5301 "glib-2.0.vapi"
	return result;
#line 1269 "NavigationRail.c"
}

static void
he_navigation_rail_on_stack_pages_changed (HeNavigationRail* self,
                                           guint position,
                                           guint removed,
                                           guint added)
{
#line 277 "../lib/Widgets/NavigationRail.vala"
	g_return_if_fail (self != NULL);
#line 279 "../lib/Widgets/NavigationRail.vala"
	while (TRUE) {
#line 1282 "NavigationRail.c"
		gboolean _tmp0_ = FALSE;
		guint _tmp1_;
		GList* button_link = NULL;
		GList* _tmp4_;
		GList* _tmp5_;
		GList* _tmp6_;
		gconstpointer _tmp7_;
		GList* link = NULL;
		GList* _tmp8_;
		GList* _tmp9_;
		GList* _tmp10_;
		GList* _tmp11_;
#line 279 "../lib/Widgets/NavigationRail.vala"
		_tmp1_ = removed;
#line 279 "../lib/Widgets/NavigationRail.vala"
		removed = _tmp1_ - 1;
#line 279 "../lib/Widgets/NavigationRail.vala"
		if (_tmp1_ > ((guint) 0)) {
#line 1301 "NavigationRail.c"
			GList* _tmp2_;
			GList* _tmp3_;
#line 279 "../lib/Widgets/NavigationRail.vala"
			_tmp2_ = self->priv->_buttons;
#line 279 "../lib/Widgets/NavigationRail.vala"
			_tmp3_ = g_list_nth (_tmp2_, position);
#line 279 "../lib/Widgets/NavigationRail.vala"
			_tmp0_ = _tmp3_ != NULL;
#line 1310 "NavigationRail.c"
		} else {
#line 279 "../lib/Widgets/NavigationRail.vala"
			_tmp0_ = FALSE;
#line 1314 "NavigationRail.c"
		}
#line 279 "../lib/Widgets/NavigationRail.vala"
		if (!_tmp0_) {
#line 279 "../lib/Widgets/NavigationRail.vala"
			break;
#line 1320 "NavigationRail.c"
		}
#line 280 "../lib/Widgets/NavigationRail.vala"
		_tmp4_ = self->priv->_buttons;
#line 280 "../lib/Widgets/NavigationRail.vala"
		_tmp5_ = g_list_nth (_tmp4_, position);
#line 280 "../lib/Widgets/NavigationRail.vala"
		button_link = _tmp5_;
#line 281 "../lib/Widgets/NavigationRail.vala"
		_tmp6_ = button_link;
#line 281 "../lib/Widgets/NavigationRail.vala"
		_tmp7_ = _tmp6_->data;
#line 281 "../lib/Widgets/NavigationRail.vala"
		gtk_widget_unparent ((GtkWidget*) ((GtkToggleButton*) _tmp7_));
#line 282 "../lib/Widgets/NavigationRail.vala"
		_tmp8_ = button_link;
#line 282 "../lib/Widgets/NavigationRail.vala"
		link = _tmp8_;
#line 283 "../lib/Widgets/NavigationRail.vala"
		_tmp9_ = button_link;
#line 283 "../lib/Widgets/NavigationRail.vala"
		_tmp10_ = _tmp9_->next;
#line 283 "../lib/Widgets/NavigationRail.vala"
		button_link = _tmp10_;
#line 284 "../lib/Widgets/NavigationRail.vala"
		_tmp11_ = link;
#line 284 "../lib/Widgets/NavigationRail.vala"
		self->priv->_buttons = g_list_delete_link (self->priv->_buttons, _tmp11_);
#line 1348 "NavigationRail.c"
	}
#line 288 "../lib/Widgets/NavigationRail.vala"
	while (TRUE) {
#line 1352 "NavigationRail.c"
		Block12Data* _data12_;
		guint _tmp12_;
		GList* button_link = NULL;
		GList* _tmp13_;
		GList* _tmp14_;
		GtkStackPage* page = NULL;
		GtkSelectionModel* _tmp15_;
		GObject* _tmp16_;
		GtkSelectionModel* _tmp17_;
		GtkToggleButton* _tmp18_ = NULL;
		GtkToggleButton* _tmp19_;
		GtkImage* button_child_image = NULL;
		GtkImage* _tmp20_;
		GtkImage* _tmp21_;
		GtkStackPage* _tmp22_;
		GtkImage* _tmp23_;
		GtkLabel* button_child_label = NULL;
		GtkLabel* _tmp24_;
		GtkLabel* _tmp25_;
		GtkStackPage* _tmp26_;
		GtkLabel* _tmp27_;
		GtkLabel* _tmp28_;
		GtkImage* _tmp29_;
		GtkBox* button_child = NULL;
		GtkBox* _tmp30_;
		GtkBox* _tmp31_;
		GtkImage* _tmp32_;
		GtkBox* _tmp33_;
		GtkLabel* _tmp34_;
		GtkToggleButton* _tmp35_;
		GtkToggleButton* _tmp36_;
		GtkBox* _tmp37_;
		GtkBox* _tmp38_;
		GtkToggleButton* _tmp39_;
		GList* _tmp40_;
		GList* _tmp44_;
		GtkToggleButton* _tmp45_;
		GtkToggleButton* _tmp46_;
		GtkStackPage* _tmp47_;
		GtkToggleButton* _tmp48_;
		gboolean _tmp49_;
		gboolean _tmp50_;
		guint _tmp51_;
#line 288 "../lib/Widgets/NavigationRail.vala"
		_data12_ = g_slice_new0 (Block12Data);
#line 288 "../lib/Widgets/NavigationRail.vala"
		_data12_->_ref_count_ = 1;
#line 288 "../lib/Widgets/NavigationRail.vala"
		_data12_->self = g_object_ref (self);
#line 288 "../lib/Widgets/NavigationRail.vala"
		_tmp12_ = added;
#line 288 "../lib/Widgets/NavigationRail.vala"
		added = _tmp12_ - 1;
#line 288 "../lib/Widgets/NavigationRail.vala"
		if (!(_tmp12_ > ((guint) 0))) {
#line 288 "../lib/Widgets/NavigationRail.vala"
			block12_data_unref (_data12_);
#line 288 "../lib/Widgets/NavigationRail.vala"
			_data12_ = NULL;
#line 288 "../lib/Widgets/NavigationRail.vala"
			break;
#line 1414 "NavigationRail.c"
		}
#line 289 "../lib/Widgets/NavigationRail.vala"
		_tmp13_ = self->priv->_buttons;
#line 289 "../lib/Widgets/NavigationRail.vala"
		_tmp14_ = g_list_nth (_tmp13_, position);
#line 289 "../lib/Widgets/NavigationRail.vala"
		button_link = _tmp14_;
#line 290 "../lib/Widgets/NavigationRail.vala"
		_tmp15_ = self->priv->_stack_pages;
#line 290 "../lib/Widgets/NavigationRail.vala"
		_tmp16_ = g_list_model_get_item ((GListModel*) _tmp15_, position);
#line 290 "../lib/Widgets/NavigationRail.vala"
		page = G_TYPE_CHECK_INSTANCE_CAST (_tmp16_, gtk_stack_page_get_type (), GtkStackPage);
#line 292 "../lib/Widgets/NavigationRail.vala"
		_tmp17_ = self->priv->_stack_pages;
#line 292 "../lib/Widgets/NavigationRail.vala"
		_tmp18_ = (GtkToggleButton*) gtk_toggle_button_new ();
#line 292 "../lib/Widgets/NavigationRail.vala"
		gtk_toggle_button_set_active (_tmp18_, gtk_selection_model_is_selected (_tmp17_, position));
#line 292 "../lib/Widgets/NavigationRail.vala"
		gtk_widget_set_valign ((GtkWidget*) _tmp18_, GTK_ALIGN_CENTER);
#line 292 "../lib/Widgets/NavigationRail.vala"
		g_object_ref_sink (_tmp18_);
#line 292 "../lib/Widgets/NavigationRail.vala"
		_data12_->button = _tmp18_;
#line 296 "../lib/Widgets/NavigationRail.vala"
		_tmp19_ = _data12_->button;
#line 296 "../lib/Widgets/NavigationRail.vala"
		gtk_widget_add_css_class ((GtkWidget*) _tmp19_, "navigation-rail-button");
#line 298 "../lib/Widgets/NavigationRail.vala"
		_tmp20_ = (GtkImage*) gtk_image_new ();
#line 298 "../lib/Widgets/NavigationRail.vala"
		g_object_ref_sink (_tmp20_);
#line 298 "../lib/Widgets/NavigationRail.vala"
		button_child_image = _tmp20_;
#line 299 "../lib/Widgets/NavigationRail.vala"
		_tmp21_ = button_child_image;
#line 299 "../lib/Widgets/NavigationRail.vala"
		gtk_widget_set_valign ((GtkWidget*) _tmp21_, GTK_ALIGN_CENTER);
#line 300 "../lib/Widgets/NavigationRail.vala"
		_tmp22_ = page;
#line 300 "../lib/Widgets/NavigationRail.vala"
		_tmp23_ = button_child_image;
#line 300 "../lib/Widgets/NavigationRail.vala"
		g_object_bind_property_with_closures ((GObject*) _tmp22_, "icon_name", (GObject*) _tmp23_, "icon_name", G_BINDING_SYNC_CREATE, (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)), (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)));
#line 302 "../lib/Widgets/NavigationRail.vala"
		_tmp24_ = (GtkLabel*) gtk_label_new ("");
#line 302 "../lib/Widgets/NavigationRail.vala"
		g_object_ref_sink (_tmp24_);
#line 302 "../lib/Widgets/NavigationRail.vala"
		button_child_label = _tmp24_;
#line 303 "../lib/Widgets/NavigationRail.vala"
		_tmp25_ = button_child_label;
#line 303 "../lib/Widgets/NavigationRail.vala"
		gtk_widget_set_valign ((GtkWidget*) _tmp25_, GTK_ALIGN_CENTER);
#line 304 "../lib/Widgets/NavigationRail.vala"
		_tmp26_ = page;
#line 304 "../lib/Widgets/NavigationRail.vala"
		_tmp27_ = button_child_label;
#line 304 "../lib/Widgets/NavigationRail.vala"
		g_object_bind_property_with_closures ((GObject*) _tmp26_, "title", (GObject*) _tmp27_, "label", G_BINDING_SYNC_CREATE, (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)), (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)));
#line 306 "../lib/Widgets/NavigationRail.vala"
		_tmp28_ = button_child_label;
#line 306 "../lib/Widgets/NavigationRail.vala"
		gtk_widget_set_visible ((GtkWidget*) _tmp28_, !self->priv->_hide_labels);
#line 307 "../lib/Widgets/NavigationRail.vala"
		_tmp29_ = button_child_image;
#line 307 "../lib/Widgets/NavigationRail.vala"
		gtk_widget_set_vexpand ((GtkWidget*) _tmp29_, self->priv->_hide_labels);
#line 309 "../lib/Widgets/NavigationRail.vala"
		_tmp30_ = (GtkBox*) gtk_box_new (GTK_ORIENTATION_VERTICAL, 0);
#line 309 "../lib/Widgets/NavigationRail.vala"
		g_object_ref_sink (_tmp30_);
#line 309 "../lib/Widgets/NavigationRail.vala"
		button_child = _tmp30_;
#line 310 "../lib/Widgets/NavigationRail.vala"
		_tmp31_ = button_child;
#line 310 "../lib/Widgets/NavigationRail.vala"
		_tmp32_ = button_child_image;
#line 310 "../lib/Widgets/NavigationRail.vala"
		gtk_box_append (_tmp31_, (GtkWidget*) _tmp32_);
#line 311 "../lib/Widgets/NavigationRail.vala"
		_tmp33_ = button_child;
#line 311 "../lib/Widgets/NavigationRail.vala"
		_tmp34_ = button_child_label;
#line 311 "../lib/Widgets/NavigationRail.vala"
		gtk_box_append (_tmp33_, (GtkWidget*) _tmp34_);
#line 313 "../lib/Widgets/NavigationRail.vala"
		_tmp35_ = _data12_->button;
#line 313 "../lib/Widgets/NavigationRail.vala"
		g_signal_connect_data (_tmp35_, "toggled", (GCallback) ____lambda142__gtk_toggle_button_toggled, block12_data_ref (_data12_), (GClosureNotify) block12_data_unref, 0);
#line 314 "../lib/Widgets/NavigationRail.vala"
		_tmp36_ = _data12_->button;
#line 314 "../lib/Widgets/NavigationRail.vala"
		_tmp37_ = button_child;
#line 314 "../lib/Widgets/NavigationRail.vala"
		gtk_button_set_child ((GtkButton*) _tmp36_, (GtkWidget*) _tmp37_);
#line 315 "../lib/Widgets/NavigationRail.vala"
		_tmp38_ = self->priv->main_box;
#line 315 "../lib/Widgets/NavigationRail.vala"
		_tmp39_ = _data12_->button;
#line 315 "../lib/Widgets/NavigationRail.vala"
		gtk_box_append (_tmp38_, (GtkWidget*) _tmp39_);
#line 317 "../lib/Widgets/NavigationRail.vala"
		_tmp40_ = self->priv->_buttons;
#line 317 "../lib/Widgets/NavigationRail.vala"
		if (!vala_g_list_is_empty (_tmp40_)) {
#line 1522 "NavigationRail.c"
			GtkToggleButton* _tmp41_;
			GList* _tmp42_;
			gconstpointer _tmp43_;
#line 318 "../lib/Widgets/NavigationRail.vala"
			_tmp41_ = _data12_->button;
#line 318 "../lib/Widgets/NavigationRail.vala"
			_tmp42_ = self->priv->_buttons;
#line 318 "../lib/Widgets/NavigationRail.vala"
			_tmp43_ = g_list_nth_data (_tmp42_, (guint) 0);
#line 318 "../lib/Widgets/NavigationRail.vala"
			gtk_toggle_button_set_group (_tmp41_, G_TYPE_CHECK_INSTANCE_CAST ((GtkToggleButton*) _tmp43_, gtk_toggle_button_get_type (), GtkToggleButton));
#line 1534 "NavigationRail.c"
		}
#line 321 "../lib/Widgets/NavigationRail.vala"
		_tmp44_ = button_link;
#line 321 "../lib/Widgets/NavigationRail.vala"
		_tmp45_ = _data12_->button;
#line 321 "../lib/Widgets/NavigationRail.vala"
		_tmp46_ = _g_object_ref0 (_tmp45_);
#line 321 "../lib/Widgets/NavigationRail.vala"
		self->priv->_buttons = g_list_insert_before (self->priv->_buttons, _tmp44_, _tmp46_);
#line 324 "../lib/Widgets/NavigationRail.vala"
		_tmp47_ = page;
#line 324 "../lib/Widgets/NavigationRail.vala"
		_tmp48_ = _data12_->button;
#line 324 "../lib/Widgets/NavigationRail.vala"
		_tmp49_ = gtk_toggle_button_get_active (_tmp48_);
#line 324 "../lib/Widgets/NavigationRail.vala"
		_tmp50_ = _tmp49_;
#line 324 "../lib/Widgets/NavigationRail.vala"
		he_navigation_rail_update_page_icon (self, _tmp47_, _tmp50_);
#line 326 "../lib/Widgets/NavigationRail.vala"
		_tmp51_ = position;
#line 326 "../lib/Widgets/NavigationRail.vala"
		position = _tmp51_ + 1;
#line 288 "../lib/Widgets/NavigationRail.vala"
		_g_object_unref0 (button_child);
#line 288 "../lib/Widgets/NavigationRail.vala"
		_g_object_unref0 (button_child_label);
#line 288 "../lib/Widgets/NavigationRail.vala"
		_g_object_unref0 (button_child_image);
#line 288 "../lib/Widgets/NavigationRail.vala"
		_g_object_unref0 (page);
#line 288 "../lib/Widgets/NavigationRail.vala"
		block12_data_unref (_data12_);
#line 288 "../lib/Widgets/NavigationRail.vala"
		_data12_ = NULL;
#line 1570 "NavigationRail.c"
	}
}

static void
he_navigation_rail_on_selected_stack_page_changed (HeNavigationRail* self,
                                                   guint position,
                                                   guint n_items)
{
	GList* button_link = NULL;
	GList* _tmp0_;
	GList* _tmp1_;
	guint current_position = 0U;
#line 330 "../lib/Widgets/NavigationRail.vala"
	g_return_if_fail (self != NULL);
#line 331 "../lib/Widgets/NavigationRail.vala"
	_tmp0_ = self->priv->_buttons;
#line 331 "../lib/Widgets/NavigationRail.vala"
	_tmp1_ = g_list_nth (_tmp0_, position);
#line 331 "../lib/Widgets/NavigationRail.vala"
	button_link = _tmp1_;
#line 332 "../lib/Widgets/NavigationRail.vala"
	current_position = position;
#line 334 "../lib/Widgets/NavigationRail.vala"
	while (TRUE) {
#line 1595 "NavigationRail.c"
		gboolean _tmp2_ = FALSE;
		guint _tmp3_;
		gboolean is_selected = FALSE;
		GtkSelectionModel* _tmp5_;
		GList* _tmp6_;
		gconstpointer _tmp7_;
		GtkStackPage* page = NULL;
		GtkSelectionModel* _tmp8_;
		GObject* _tmp9_;
		GtkStackPage* _tmp10_;
		GList* _tmp11_;
		GList* _tmp12_;
		guint _tmp13_;
#line 334 "../lib/Widgets/NavigationRail.vala"
		_tmp3_ = n_items;
#line 334 "../lib/Widgets/NavigationRail.vala"
		n_items = _tmp3_ - 1;
#line 334 "../lib/Widgets/NavigationRail.vala"
		if (_tmp3_ > ((guint) 0)) {
#line 1615 "NavigationRail.c"
			GList* _tmp4_;
#line 334 "../lib/Widgets/NavigationRail.vala"
			_tmp4_ = button_link;
#line 334 "../lib/Widgets/NavigationRail.vala"
			_tmp2_ = _tmp4_ != NULL;
#line 1621 "NavigationRail.c"
		} else {
#line 334 "../lib/Widgets/NavigationRail.vala"
			_tmp2_ = FALSE;
#line 1625 "NavigationRail.c"
		}
#line 334 "../lib/Widgets/NavigationRail.vala"
		if (!_tmp2_) {
#line 334 "../lib/Widgets/NavigationRail.vala"
			break;
#line 1631 "NavigationRail.c"
		}
#line 335 "../lib/Widgets/NavigationRail.vala"
		_tmp5_ = self->priv->_stack_pages;
#line 335 "../lib/Widgets/NavigationRail.vala"
		is_selected = gtk_selection_model_is_selected (_tmp5_, current_position);
#line 336 "../lib/Widgets/NavigationRail.vala"
		_tmp6_ = button_link;
#line 336 "../lib/Widgets/NavigationRail.vala"
		_tmp7_ = _tmp6_->data;
#line 336 "../lib/Widgets/NavigationRail.vala"
		gtk_toggle_button_set_active ((GtkToggleButton*) _tmp7_, is_selected);
#line 338 "../lib/Widgets/NavigationRail.vala"
		_tmp8_ = self->priv->_stack_pages;
#line 338 "../lib/Widgets/NavigationRail.vala"
		_tmp9_ = g_list_model_get_item ((GListModel*) _tmp8_, current_position);
#line 338 "../lib/Widgets/NavigationRail.vala"
		page = G_TYPE_CHECK_INSTANCE_CAST (_tmp9_, gtk_stack_page_get_type (), GtkStackPage);
#line 339 "../lib/Widgets/NavigationRail.vala"
		_tmp10_ = page;
#line 339 "../lib/Widgets/NavigationRail.vala"
		he_navigation_rail_update_page_icon (self, _tmp10_, is_selected);
#line 341 "../lib/Widgets/NavigationRail.vala"
		_tmp11_ = button_link;
#line 341 "../lib/Widgets/NavigationRail.vala"
		_tmp12_ = _tmp11_->next;
#line 341 "../lib/Widgets/NavigationRail.vala"
		button_link = _tmp12_;
#line 342 "../lib/Widgets/NavigationRail.vala"
		_tmp13_ = current_position;
#line 342 "../lib/Widgets/NavigationRail.vala"
		current_position = _tmp13_ + 1;
#line 334 "../lib/Widgets/NavigationRail.vala"
		_g_object_unref0 (page);
#line 1665 "NavigationRail.c"
	}
}

static void
he_navigation_rail_on_button_toggled (HeNavigationRail* self,
                                      GtkToggleButton* button)
{
	GtkSelectionModel* _tmp0_;
	gint position = 0;
	GList* _tmp1_;
	GtkStackPage* page = NULL;
	GtkSelectionModel* _tmp2_;
	GObject* _tmp3_;
	gboolean _tmp4_;
	gboolean _tmp5_;
#line 346 "../lib/Widgets/NavigationRail.vala"
	g_return_if_fail (self != NULL);
#line 346 "../lib/Widgets/NavigationRail.vala"
	g_return_if_fail (button != NULL);
#line 347 "../lib/Widgets/NavigationRail.vala"
	_tmp0_ = self->priv->_stack_pages;
#line 347 "../lib/Widgets/NavigationRail.vala"
	if (g_list_model_get_n_items ((GListModel*) _tmp0_) <= ((guint) 1)) {
#line 348 "../lib/Widgets/NavigationRail.vala"
		return;
#line 1691 "NavigationRail.c"
	}
#line 351 "../lib/Widgets/NavigationRail.vala"
	_tmp1_ = self->priv->_buttons;
#line 351 "../lib/Widgets/NavigationRail.vala"
	position = g_list_index (_tmp1_, button);
#line 352 "../lib/Widgets/NavigationRail.vala"
	if (position < 0) {
#line 352 "../lib/Widgets/NavigationRail.vala"
		return;
#line 1701 "NavigationRail.c"
	}
#line 354 "../lib/Widgets/NavigationRail.vala"
	_tmp2_ = self->priv->_stack_pages;
#line 354 "../lib/Widgets/NavigationRail.vala"
	_tmp3_ = g_list_model_get_item ((GListModel*) _tmp2_, (guint) position);
#line 354 "../lib/Widgets/NavigationRail.vala"
	page = G_TYPE_CHECK_INSTANCE_CAST (_tmp3_, gtk_stack_page_get_type (), GtkStackPage);
#line 356 "../lib/Widgets/NavigationRail.vala"
	_tmp4_ = gtk_toggle_button_get_active (button);
#line 356 "../lib/Widgets/NavigationRail.vala"
	_tmp5_ = _tmp4_;
#line 356 "../lib/Widgets/NavigationRail.vala"
	if (_tmp5_) {
#line 1715 "NavigationRail.c"
		GtkSelectionModel* _tmp6_;
		GtkStackPage* _tmp7_;
#line 357 "../lib/Widgets/NavigationRail.vala"
		_tmp6_ = self->priv->_stack_pages;
#line 357 "../lib/Widgets/NavigationRail.vala"
		gtk_selection_model_select_item (_tmp6_, (guint) position, TRUE);
#line 358 "../lib/Widgets/NavigationRail.vala"
		_tmp7_ = page;
#line 358 "../lib/Widgets/NavigationRail.vala"
		he_navigation_rail_update_page_icon (self, _tmp7_, TRUE);
#line 1726 "NavigationRail.c"
	} else {
		GtkStackPage* _tmp8_;
#line 360 "../lib/Widgets/NavigationRail.vala"
		_tmp8_ = page;
#line 360 "../lib/Widgets/NavigationRail.vala"
		he_navigation_rail_update_page_icon (self, _tmp8_, FALSE);
#line 1733 "NavigationRail.c"
	}
#line 346 "../lib/Widgets/NavigationRail.vala"
	_g_object_unref0 (page);
#line 1737 "NavigationRail.c"
}

static void
_he_navigation_rail___lambda143_ (HeNavigationRail* self)
{
	gboolean _tmp0_;
	gboolean _tmp1_;
#line 176 "../lib/Widgets/NavigationRail.vala"
	_tmp0_ = he_navigation_rail_get_is_expanded (self);
#line 176 "../lib/Widgets/NavigationRail.vala"
	_tmp1_ = _tmp0_;
#line 176 "../lib/Widgets/NavigationRail.vala"
	he_navigation_rail_set_is_expanded (self, !_tmp1_);
#line 1751 "NavigationRail.c"
}

static void
__he_navigation_rail___lambda143__gtk_button_clicked (GtkButton* _sender,
                                                      gpointer self)
{
#line 175 "../lib/Widgets/NavigationRail.vala"
	_he_navigation_rail___lambda143_ ((HeNavigationRail*) self);
#line 1760 "NavigationRail.c"
}

static GObject *
he_navigation_rail_constructor (GType type,
                                guint n_construct_properties,
                                GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	HeNavigationRail * self;
	GtkBox* _tmp0_;
	GtkBox* _tmp1_;
	GtkBox* _tmp2_;
	HeButton* _tmp3_;
	HeButton* _tmp4_;
	HeButton* _tmp5_;
	HeButton* _tmp6_;
	HeButton* _tmp7_;
	HeButton* _tmp8_;
	HeButton* _tmp9_;
	HeButton* _tmp10_;
	GtkBox* _tmp11_;
	HeButton* _tmp12_;
#line 162 "../lib/Widgets/NavigationRail.vala"
	parent_class = G_OBJECT_CLASS (he_navigation_rail_parent_class);
#line 162 "../lib/Widgets/NavigationRail.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 162 "../lib/Widgets/NavigationRail.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, HE_TYPE_NAVIGATION_RAIL, HeNavigationRail);
#line 163 "../lib/Widgets/NavigationRail.vala"
	_tmp0_ = self->priv->main_box;
#line 163 "../lib/Widgets/NavigationRail.vala"
	gtk_widget_add_css_class ((GtkWidget*) _tmp0_, "navigation-rail");
#line 164 "../lib/Widgets/NavigationRail.vala"
	_tmp1_ = self->priv->main_box;
#line 164 "../lib/Widgets/NavigationRail.vala"
	gtk_widget_set_parent ((GtkWidget*) _tmp1_, (GtkWidget*) self);
#line 165 "../lib/Widgets/NavigationRail.vala"
	_tmp2_ = self->priv->main_box;
#line 165 "../lib/Widgets/NavigationRail.vala"
	gtk_widget_set_hexpand ((GtkWidget*) _tmp2_, TRUE);
#line 166 "../lib/Widgets/NavigationRail.vala"
	self->priv->_is_expanded = FALSE;
#line 168 "../lib/Widgets/NavigationRail.vala"
	_tmp3_ = he_button_new ("", "");
#line 168 "../lib/Widgets/NavigationRail.vala"
	g_object_ref_sink (_tmp3_);
#line 168 "../lib/Widgets/NavigationRail.vala"
	_g_object_unref0 (self->priv->expand_button);
#line 168 "../lib/Widgets/NavigationRail.vala"
	self->priv->expand_button = _tmp3_;
#line 169 "../lib/Widgets/NavigationRail.vala"
	_tmp4_ = self->priv->expand_button;
#line 169 "../lib/Widgets/NavigationRail.vala"
	he_button_set_is_iconic (_tmp4_, TRUE);
#line 170 "../lib/Widgets/NavigationRail.vala"
	_tmp5_ = self->priv->expand_button;
#line 170 "../lib/Widgets/NavigationRail.vala"
	gtk_widget_set_halign ((GtkWidget*) _tmp5_, GTK_ALIGN_START);
#line 171 "../lib/Widgets/NavigationRail.vala"
	_tmp6_ = self->priv->expand_button;
#line 171 "../lib/Widgets/NavigationRail.vala"
	gtk_widget_set_valign ((GtkWidget*) _tmp6_, GTK_ALIGN_CENTER);
#line 172 "../lib/Widgets/NavigationRail.vala"
	_tmp7_ = self->priv->expand_button;
#line 172 "../lib/Widgets/NavigationRail.vala"
	gtk_widget_set_margin_bottom ((GtkWidget*) _tmp7_, 18);
#line 173 "../lib/Widgets/NavigationRail.vala"
	_tmp8_ = self->priv->expand_button;
#line 173 "../lib/Widgets/NavigationRail.vala"
	gtk_widget_set_tooltip_text ((GtkWidget*) _tmp8_, _ ("Expand/Collapse"));
#line 174 "../lib/Widgets/NavigationRail.vala"
	_tmp9_ = self->priv->expand_button;
#line 174 "../lib/Widgets/NavigationRail.vala"
	gtk_widget_add_css_class ((GtkWidget*) _tmp9_, "navigation-rail-expand-button");
#line 175 "../lib/Widgets/NavigationRail.vala"
	_tmp10_ = self->priv->expand_button;
#line 175 "../lib/Widgets/NavigationRail.vala"
	g_signal_connect_object ((GtkButton*) _tmp10_, "clicked", (GCallback) __he_navigation_rail___lambda143__gtk_button_clicked, self, 0);
#line 178 "../lib/Widgets/NavigationRail.vala"
	_tmp11_ = self->priv->main_box;
#line 178 "../lib/Widgets/NavigationRail.vala"
	_tmp12_ = self->priv->expand_button;
#line 178 "../lib/Widgets/NavigationRail.vala"
	gtk_box_prepend (_tmp11_, (GtkWidget*) _tmp12_);
#line 180 "../lib/Widgets/NavigationRail.vala"
	gtk_widget_add_css_class ((GtkWidget*) self, "sidebar-view");
#line 181 "../lib/Widgets/NavigationRail.vala"
	he_navigation_rail_update_orientation_layout (self);
#line 182 "../lib/Widgets/NavigationRail.vala"
	he_navigation_rail_update_expansion_state (self);
#line 162 "../lib/Widgets/NavigationRail.vala"
	return obj;
#line 1854 "NavigationRail.c"
}

static void
he_navigation_rail_class_init (HeNavigationRailClass * klass,
                               gpointer klass_data)
{
#line 23 "../lib/Widgets/NavigationRail.vala"
	he_navigation_rail_parent_class = g_type_class_peek_parent (klass);
#line 23 "../lib/Widgets/NavigationRail.vala"
	g_type_class_adjust_private_offset (klass, &HeNavigationRail_private_offset);
#line 23 "../lib/Widgets/NavigationRail.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_he_navigation_rail_get_property;
#line 23 "../lib/Widgets/NavigationRail.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_he_navigation_rail_set_property;
#line 23 "../lib/Widgets/NavigationRail.vala"
	G_OBJECT_CLASS (klass)->constructor = he_navigation_rail_constructor;
#line 23 "../lib/Widgets/NavigationRail.vala"
	G_OBJECT_CLASS (klass)->finalize = he_navigation_rail_finalize;
#line 1873 "NavigationRail.c"
	/**
	     * The stack that is controlled by this switcher.
	     *
	     * @since 1.0
	     */
#line 23 "../lib/Widgets/NavigationRail.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), HE_NAVIGATION_RAIL_STACK_PROPERTY, he_navigation_rail_properties[HE_NAVIGATION_RAIL_STACK_PROPERTY] = g_param_spec_object ("stack", "stack", "stack", gtk_stack_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 1881 "NavigationRail.c"
	/**
	     * The orientation of this switcher.
	     *
	     * @since 1.0
	     */
#line 23 "../lib/Widgets/NavigationRail.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), HE_NAVIGATION_RAIL_ORIENTATION_PROPERTY, he_navigation_rail_properties[HE_NAVIGATION_RAIL_ORIENTATION_PROPERTY] = g_param_spec_enum ("orientation", "orientation", "orientation", gtk_orientation_get_type (), 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 1889 "NavigationRail.c"
	/**
	     * Whether to hide the item labels or not. Useful if the icon for the item is descriptive enough.
	     *
	     * @since 1.0
	     */
#line 23 "../lib/Widgets/NavigationRail.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), HE_NAVIGATION_RAIL_HIDE_LABELS_PROPERTY, he_navigation_rail_properties[HE_NAVIGATION_RAIL_HIDE_LABELS_PROPERTY] = g_param_spec_boolean ("hide-labels", "hide-labels", "hide-labels", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 1897 "NavigationRail.c"
	/**
	     * Whether the navigation rail is expanded or collapsed.
	     *
	     * @since 1.0
	     */
#line 23 "../lib/Widgets/NavigationRail.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), HE_NAVIGATION_RAIL_IS_EXPANDED_PROPERTY, he_navigation_rail_properties[HE_NAVIGATION_RAIL_IS_EXPANDED_PROPERTY] = g_param_spec_boolean ("is-expanded", "is-expanded", "is-expanded", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 1905 "NavigationRail.c"
	/**
	     * Custom button to show between expand button and navigation buttons.
	     *
	     * @since 1.0
	     */
#line 23 "../lib/Widgets/NavigationRail.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), HE_NAVIGATION_RAIL_CUSTOM_BUTTON_PROPERTY, he_navigation_rail_properties[HE_NAVIGATION_RAIL_CUSTOM_BUTTON_PROPERTY] = g_param_spec_object ("custom-button", "custom-button", "custom-button", gtk_button_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 1913 "NavigationRail.c"
	/**
	     * Custom widget to show after navigation buttons (vertical + expanded only).
	     *
	     * @since 1.0
	     */
#line 23 "../lib/Widgets/NavigationRail.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), HE_NAVIGATION_RAIL_CUSTOM_WIDGET_PROPERTY, he_navigation_rail_properties[HE_NAVIGATION_RAIL_CUSTOM_WIDGET_PROPERTY] = g_param_spec_object ("custom-widget", "custom-widget", "custom-widget", gtk_widget_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 159 "../lib/Widgets/NavigationRail.vala"
	gtk_widget_class_set_layout_manager_type (GTK_WIDGET_CLASS (klass), gtk_box_layout_get_type ());
#line 1923 "NavigationRail.c"
}

static void
he_navigation_rail_instance_init (HeNavigationRail * self,
                                  gpointer klass)
{
	GtkBox* _tmp0_;
#line 23 "../lib/Widgets/NavigationRail.vala"
	self->priv = he_navigation_rail_get_instance_private (self);
#line 26 "../lib/Widgets/NavigationRail.vala"
	_tmp0_ = (GtkBox*) gtk_box_new (GTK_ORIENTATION_VERTICAL, 0);
#line 26 "../lib/Widgets/NavigationRail.vala"
	g_object_ref_sink (_tmp0_);
#line 26 "../lib/Widgets/NavigationRail.vala"
	self->priv->main_box = _tmp0_;
#line 57 "../lib/Widgets/NavigationRail.vala"
	self->priv->_orientation = GTK_ORIENTATION_VERTICAL;
#line 73 "../lib/Widgets/NavigationRail.vala"
	self->priv->_hide_labels = FALSE;
#line 89 "../lib/Widgets/NavigationRail.vala"
	self->priv->_is_expanded = TRUE;
#line 1945 "NavigationRail.c"
}

static void
he_navigation_rail_finalize (GObject * obj)
{
	HeNavigationRail * self;
#line 23 "../lib/Widgets/NavigationRail.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, HE_TYPE_NAVIGATION_RAIL, HeNavigationRail);
#line 24 "../lib/Widgets/NavigationRail.vala"
	_g_object_unref0 (self->priv->_stack_pages);
#line 25 "../lib/Widgets/NavigationRail.vala"
	(self->priv->_buttons == NULL) ? NULL : (self->priv->_buttons = (_g_list_free__g_object_unref0_ (self->priv->_buttons), NULL));
#line 26 "../lib/Widgets/NavigationRail.vala"
	_g_object_unref0 (self->priv->main_box);
#line 27 "../lib/Widgets/NavigationRail.vala"
	_g_object_unref0 (self->priv->expand_button);
#line 28 "../lib/Widgets/NavigationRail.vala"
	_g_object_unref0 (self->priv->_custom_button);
#line 29 "../lib/Widgets/NavigationRail.vala"
	_g_object_unref0 (self->priv->_custom_widget);
#line 31 "../lib/Widgets/NavigationRail.vala"
	_g_object_unref0 (self->priv->_stack);
#line 23 "../lib/Widgets/NavigationRail.vala"
	G_OBJECT_CLASS (he_navigation_rail_parent_class)->finalize (obj);
#line 1970 "NavigationRail.c"
}

/**
 * A NavigationRail is a vertical switcher that helps navigate a stack.
 */
static GType
he_navigation_rail_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (HeNavigationRailClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) he_navigation_rail_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (HeNavigationRail), 0, (GInstanceInitFunc) he_navigation_rail_instance_init, NULL };
	GType he_navigation_rail_type_id;
	he_navigation_rail_type_id = g_type_register_static (HE_TYPE_BIN, "HeNavigationRail", &g_define_type_info, 0);
	HeNavigationRail_private_offset = g_type_add_instance_private (he_navigation_rail_type_id, sizeof (HeNavigationRailPrivate));
	return he_navigation_rail_type_id;
}

GType
he_navigation_rail_get_type (void)
{
	static volatile gsize he_navigation_rail_type_id__once = 0;
	if (g_once_init_enter (&he_navigation_rail_type_id__once)) {
		GType he_navigation_rail_type_id;
		he_navigation_rail_type_id = he_navigation_rail_get_type_once ();
		g_once_init_leave (&he_navigation_rail_type_id__once, he_navigation_rail_type_id);
	}
	return he_navigation_rail_type_id__once;
}

static void
_vala_he_navigation_rail_get_property (GObject * object,
                                       guint property_id,
                                       GValue * value,
                                       GParamSpec * pspec)
{
	HeNavigationRail * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, HE_TYPE_NAVIGATION_RAIL, HeNavigationRail);
#line 23 "../lib/Widgets/NavigationRail.vala"
	switch (property_id) {
#line 23 "../lib/Widgets/NavigationRail.vala"
		case HE_NAVIGATION_RAIL_STACK_PROPERTY:
#line 23 "../lib/Widgets/NavigationRail.vala"
		g_value_set_object (value, he_navigation_rail_get_stack (self));
#line 23 "../lib/Widgets/NavigationRail.vala"
		break;
#line 23 "../lib/Widgets/NavigationRail.vala"
		case HE_NAVIGATION_RAIL_ORIENTATION_PROPERTY:
#line 23 "../lib/Widgets/NavigationRail.vala"
		g_value_set_enum (value, he_navigation_rail_get_orientation (self));
#line 23 "../lib/Widgets/NavigationRail.vala"
		break;
#line 23 "../lib/Widgets/NavigationRail.vala"
		case HE_NAVIGATION_RAIL_HIDE_LABELS_PROPERTY:
#line 23 "../lib/Widgets/NavigationRail.vala"
		g_value_set_boolean (value, he_navigation_rail_get_hide_labels (self));
#line 23 "../lib/Widgets/NavigationRail.vala"
		break;
#line 23 "../lib/Widgets/NavigationRail.vala"
		case HE_NAVIGATION_RAIL_IS_EXPANDED_PROPERTY:
#line 23 "../lib/Widgets/NavigationRail.vala"
		g_value_set_boolean (value, he_navigation_rail_get_is_expanded (self));
#line 23 "../lib/Widgets/NavigationRail.vala"
		break;
#line 23 "../lib/Widgets/NavigationRail.vala"
		case HE_NAVIGATION_RAIL_CUSTOM_BUTTON_PROPERTY:
#line 23 "../lib/Widgets/NavigationRail.vala"
		g_value_set_object (value, he_navigation_rail_get_custom_button (self));
#line 23 "../lib/Widgets/NavigationRail.vala"
		break;
#line 23 "../lib/Widgets/NavigationRail.vala"
		case HE_NAVIGATION_RAIL_CUSTOM_WIDGET_PROPERTY:
#line 23 "../lib/Widgets/NavigationRail.vala"
		g_value_set_object (value, he_navigation_rail_get_custom_widget (self));
#line 23 "../lib/Widgets/NavigationRail.vala"
		break;
#line 2044 "NavigationRail.c"
		default:
#line 23 "../lib/Widgets/NavigationRail.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 23 "../lib/Widgets/NavigationRail.vala"
		break;
#line 2050 "NavigationRail.c"
	}
}

static void
_vala_he_navigation_rail_set_property (GObject * object,
                                       guint property_id,
                                       const GValue * value,
                                       GParamSpec * pspec)
{
	HeNavigationRail * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, HE_TYPE_NAVIGATION_RAIL, HeNavigationRail);
#line 23 "../lib/Widgets/NavigationRail.vala"
	switch (property_id) {
#line 23 "../lib/Widgets/NavigationRail.vala"
		case HE_NAVIGATION_RAIL_STACK_PROPERTY:
#line 23 "../lib/Widgets/NavigationRail.vala"
		he_navigation_rail_set_stack (self, g_value_get_object (value));
#line 23 "../lib/Widgets/NavigationRail.vala"
		break;
#line 23 "../lib/Widgets/NavigationRail.vala"
		case HE_NAVIGATION_RAIL_ORIENTATION_PROPERTY:
#line 23 "../lib/Widgets/NavigationRail.vala"
		he_navigation_rail_set_orientation (self, g_value_get_enum (value));
#line 23 "../lib/Widgets/NavigationRail.vala"
		break;
#line 23 "../lib/Widgets/NavigationRail.vala"
		case HE_NAVIGATION_RAIL_HIDE_LABELS_PROPERTY:
#line 23 "../lib/Widgets/NavigationRail.vala"
		he_navigation_rail_set_hide_labels (self, g_value_get_boolean (value));
#line 23 "../lib/Widgets/NavigationRail.vala"
		break;
#line 23 "../lib/Widgets/NavigationRail.vala"
		case HE_NAVIGATION_RAIL_IS_EXPANDED_PROPERTY:
#line 23 "../lib/Widgets/NavigationRail.vala"
		he_navigation_rail_set_is_expanded (self, g_value_get_boolean (value));
#line 23 "../lib/Widgets/NavigationRail.vala"
		break;
#line 23 "../lib/Widgets/NavigationRail.vala"
		case HE_NAVIGATION_RAIL_CUSTOM_BUTTON_PROPERTY:
#line 23 "../lib/Widgets/NavigationRail.vala"
		he_navigation_rail_set_custom_button (self, g_value_get_object (value));
#line 23 "../lib/Widgets/NavigationRail.vala"
		break;
#line 23 "../lib/Widgets/NavigationRail.vala"
		case HE_NAVIGATION_RAIL_CUSTOM_WIDGET_PROPERTY:
#line 23 "../lib/Widgets/NavigationRail.vala"
		he_navigation_rail_set_custom_widget (self, g_value_get_object (value));
#line 23 "../lib/Widgets/NavigationRail.vala"
		break;
#line 2100 "NavigationRail.c"
		default:
#line 23 "../lib/Widgets/NavigationRail.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 23 "../lib/Widgets/NavigationRail.vala"
		break;
#line 2106 "NavigationRail.c"
	}
}

static inline gpointer
_vala_memdup2 (gconstpointer mem,
               gsize byte_size)
{
	gpointer new_mem;
	if (mem && byte_size != 0) {
		new_mem = g_malloc (byte_size);
		memcpy (new_mem, mem, byte_size);
	} else {
		new_mem = NULL;
	}
	return new_mem;
}

